"use strict";

exports.__esModule = true;
exports.AdvancedFind = void 0;

var _InterpreterValue = require("../interpreter/InterpreterValue");

/**
 * @license
 * Copyright (c) 2022 Handsoncode. All rights reserved.
 */
class AdvancedFind {
  constructor(dependencyGraph) {
    this.dependencyGraph = dependencyGraph;
  }

  advancedFind(keyMatcher, rangeValue) {
    let values;
    const range = rangeValue.range;

    if (range === undefined) {
      values = rangeValue.valuesFromTopLeftCorner();
    } else {
      values = this.dependencyGraph.computeListOfValuesInRange(range);
    }

    for (let i = 0; i < values.length; i++) {
      if (keyMatcher((0, _InterpreterValue.getRawValue)(values[i]))) {
        return i;
      }
    }

    return -1;
  }

}

exports.AdvancedFind = AdvancedFind;