"use strict";

exports.__esModule = true;
exports.ColumnBinarySearch = void 0;

var _ArithmeticHelper = require("../interpreter/ArithmeticHelper");

var _binarySearch = require("../interpreter/binarySearch");

var _InterpreterValue = require("../interpreter/InterpreterValue");

var _AdvancedFind = require("./AdvancedFind");

/**
 * @license
 * Copyright (c) 2022 Handsoncode. All rights reserved.
 */
class ColumnBinarySearch extends _AdvancedFind.AdvancedFind {
  constructor(dependencyGraph, config) {
    super(dependencyGraph);
    this.dependencyGraph = dependencyGraph;
    this.config = config;
  } // eslint-disable-next-line @typescript-eslint/no-unused-vars 


  add(value, address) {} // eslint-disable-next-line @typescript-eslint/no-unused-vars


  remove(value, address) {} // eslint-disable-next-line @typescript-eslint/no-unused-vars


  change(oldValue, newValue, address) {} // eslint-disable-next-line @typescript-eslint/no-unused-vars


  applyChanges(contentChanges) {} // eslint-disable-next-line @typescript-eslint/no-unused-vars


  addColumns(columnsSpan) {} // eslint-disable-next-line @typescript-eslint/no-unused-vars


  removeColumns(columnsSpan) {} // eslint-disable-next-line @typescript-eslint/no-unused-vars


  removeSheet(sheetId) {} // eslint-disable-next-line @typescript-eslint/no-unused-vars


  moveValues(sourceRange, toRight, toBottom, toSheet) {} // eslint-disable-next-line @typescript-eslint/no-unused-vars


  removeValues(range) {}

  find(key, rangeValue, sorted) {
    if (typeof key === 'string') {
      key = (0, _ArithmeticHelper.forceNormalizeString)(key);
    }

    const range = rangeValue.range;

    if (range === undefined) {
      return rangeValue.valuesFromTopLeftCorner().map(_InterpreterValue.getRawValue).map(arg => typeof arg === 'string' ? (0, _ArithmeticHelper.forceNormalizeString)(arg) : arg).indexOf(key);
    } else if (!sorted) {
      return this.dependencyGraph.computeListOfValuesInRange(range).findIndex(arg => {
        arg = (0, _InterpreterValue.getRawValue)(arg);
        arg = typeof arg === 'string' ? (0, _ArithmeticHelper.forceNormalizeString)(arg) : arg;
        return arg === key;
      });
    } else {
      return (0, _binarySearch.rangeLowerBound)(range, key, this.dependencyGraph, 'row');
    }
  }

}

exports.ColumnBinarySearch = ColumnBinarySearch;